module sema.SymbolTable;

import tango.io.Stdout;

import lexer.Token;

import ast.Exp : Identifier;

class SymbolTable
{
}

class Scope
{
    this() {}
    this(Scope enclosing)
    {
        this.enclosing = enclosing;
    }

    Scope enclosing;

    Symbol add(Identifier id)
    {
        auto s = new Symbol;
        s.id = id;
        symbols[id] = s;
        return s;
    }

    Symbol find(Identifier id)
    {
        if (auto sym = id in symbols)
            return *sym;
        if (enclosing !is null)
            return enclosing.find(id);
        return null;
    }

    char[][] names()
    {
        char[][] res;
        foreach (id, sym; symbols)
            res ~= sym.id.name ~ " : " ~ sym.type.name;
        return res;
    }

private:
    Symbol[Identifier] symbols;
}

class Symbol
{
    Identifier id;
    Identifier type;
}

